var/list/dm_keywords = list("var","tmp","in","goto","global","static","return","del","do","if","else","continue",\
"const","while","break","switch","new","as","for","set","verb","proc","arg")

proc/get_dm_keywords(text)
	var/list/result = list()
	for(var/keyword in dm_keywords)
		var/keyword_pos=findText(text, keyword)
		while(keyword_pos)
			if((keyword_pos < 2 || !isletter_or_underscore(copytext(text,keyword_pos-1,keyword_pos))) && (length(text) < keyword_pos+length(keyword) || !isletter_or_underscore(copytext(text,keyword_pos+length(keyword),keyword_pos+length(keyword)+1))))
				result["[keyword_pos]"] = keyword
			keyword_pos=findText(text, keyword, keyword_pos+1)
	return result

proc/isletter_or_underscore(char)
	var/ascii_char = text2ascii(char)
	if(ascii_char >= 97 && ascii_char <= 122) return TRUE //lower
	if(ascii_char >= 65 && ascii_char <= 90)  return TRUE //upper
	if(char == "_") return TRUE